// SharedMemoryWriter.cpp
// 2016.04 Kyoung Shin Park 
//
#include "QUANTA/QUANTAinit.hxx"
#include "QUANTA/QUANTAnet_datapack_c.hxx"
#include "SharedMemory.h"

#include <windows.h>
#include <iostream>
#include <string.h>

#define BUFFER_SIZE 4096

// shared memory 
CSharedMemory shmem("_SHMEM_TEST");
char * shmbuf;
HANDLE segment_id = (HANDLE)3782;

bool datapackActive = false;
static QUANTAnet_datapack_c dataPacker;

void parseCommandLine(int argc, char ** argv)
{
    for (int i = 1; i < argc; i++) {
		if (!strncmp(argv[i], "--", 2)) {
			if (!strncmp(argv[i], "--datapack", 10)) {
				datapackActive = true;
				printf("datapack active\n");
			}
		}
	}
}

// pack data and write data to shared memory
int packDataTo(char* buffer)
{
	char mychar = 'A';
	int myint = 20000000;
	float myfloat = 3.33f;
	unsigned long myUnsignedLong = 4000000000;
	double mydouble = 4.44444;
	long mylong = 1138;
	char mystr[8];
	strcpy(mystr, "thx1138");
	float floatArray[4] = { 1.1f, 2.2f, 3.3f, 4.4f };
	char* fullstr = "jar jar";
	printf("char = %d\n", dataPacker.sizeof_char());
	printf("int = %d\n", dataPacker.sizeof_int());
	printf("float = %d\n", dataPacker.sizeof_float());
	printf("double = %d\n", dataPacker.sizeof_double());
	printf("long = %d\n", dataPacker.sizeof_long());
	printf("unsigned long = %d\n", dataPacker.sizeof_unsignedLong());

	int dataSize = dataPacker.sizeof_float() 
		+ dataPacker.sizeof_int() 
		+ dataPacker.sizeof_double() 
		+ dataPacker.sizeof_char()
		+ dataPacker.sizeof_char(8) 
		+ dataPacker.sizeof_float(4)
		+ dataPacker.sizeof_long() 
		+ dataPacker.sizeof_unsignedLong() 
		+ dataPacker.sizeof_string(32);

	shmem.lockMutex();
	printf("Send Char: %c\n", mychar);
	printf("Send Int: %d\n", myint);
	printf("Send Long: %ld\n", mylong);
	printf("Send Unsigned Long: %lu\n", myUnsignedLong);
	printf("Send Float: %f\n", myfloat);
	printf("Send Double: %lf\n", mydouble);
	printf("Send Char*: %s\n", mystr);
	printf("Send Float Array - with the floats: ");
	for (int i = 0; i<4; i++)
		printf("%f\t", floatArray[i]);
	printf("\nSend String: %s\n", fullstr);
	dataPacker.initPack(buffer, dataSize);
	dataPacker.packFloat(myfloat);
	dataPacker.packInt(myint);
	dataPacker.packDouble(mydouble);
	dataPacker.packChar(mychar);
	dataPacker.pack(mystr, 8);
	dataPacker.packFloatArray(floatArray, 4);
	dataPacker.packLong(mylong);
	dataPacker.packUnsignedLong(myUnsignedLong);
	dataPacker.packString(fullstr);
	shmem.unlockMutex();

	int realSize = dataPacker.getBufferFilledSize();
	printf("\n\nSIZE: %d/%d\n", realSize, dataSize);

	return realSize;
}

int writeDataTo(char* buffer)
{
	static int count[2] = { 1, 1 };
	printf("%d %d\n", count[0], count[1]);
	sprintf(buffer, "%d %d", count[0]++, count[1]++);
	return sizeof(int);
}

int main(int argc, char ** argv)
{
	parseCommandLine(argc, argv);

	// initialize shared memory unit
	shmem.createMutex();
	// allocate shared memory segment
	segment_id = shmem.getShm((key_t)segment_id, BUFFER_SIZE, S_IRUSR | S_IWUSR | IPC_CREAT);
	printf("shmem id=%d\n", (int)segment_id);

	// attach the shared memory segment
	shmbuf = (char *) shmem.attachShm(segment_id, NULL, 0);
	printf("shared memory attached\n");

	// while loop
	while(1) {
		int dataSize = 0;
		if (datapackActive) {
			dataSize = packDataTo(shmbuf);
		}
		else {
			dataSize = writeDataTo(shmbuf);
		}
		printf("Data Shared Memory ߽ϴ: DataSize=%d\n", dataSize);
		Sleep(500);
	}

	// detach the shared memory segment
	shmem.detachShm(shmbuf);
	// remove the shared memory segment
	shmem.cleanShm(segment_id, IPC_RMID, NULL);
	shmem.closeMutex();
	printf("shared memory detached & cleanup \n");

	return 0;
}

